/* from fasttint.c */
static PyObject *fill_opaque_SLOW(PyObject *self, PyObject *args)
{
    /* This is slightly slower than pygame's surface fill, so I'm killing it.*/
    /* Might be able to optimize by omitting self? */
    /* Could probably also improve by using MMX and/or AltiVec, but that's likely to be Work. */
    unsigned int color;
    unsigned int x1;
    unsigned int x2;
    unsigned int y1;
    unsigned int y2;
    PyObject *pysurf;
    SDL_Surface *dst;
    if (!PyArg_ParseTuple(args, "Oiiiii", &pysurf, &x1, &y1, &x2, &y2,
        &color)) {
        return NULL;
    }
    dst = PySurface_AsSurface(pysurf);
    if (dst->w<=x2) x2 = dst->w-1;
    if (dst->h<=y2) y2 = dst->h-1;
    if (!((x1|x2)&1)) {
        register unsigned long long *dstpx = (unsigned long long *)dst->pixels;
        unsigned long long lcolor = color;
        lcolor <<= 32;
        lcolor |= color;
        const int stride = dst->pitch>>3;
        x1 >>= 1;
        register int startx = x1+(y1*stride);
        x2 >>= 1;
        const int endx = x2+(y2*stride);
        register int x = startx;
        register int xmax;
        while (x<endx) {
            xmax = x+x2;
            while (x<xmax) {
                dstpx[x] = lcolor;
                x++;
            }
            startx += stride;
            x = startx;
        }
        Py_INCREF(Py_None);
        return Py_None;
    }
    register unsigned int *dstpx = (unsigned int *)dst->pixels;
    const int stride = dst->pitch>>2;
    register int startx = x1+(y1*stride);
    const int endx = x2+(y2*stride);
    register int x = startx;
    register int xmax;
    while (x<endx) {
        xmax = x+x2;
        while (x<xmax) {
            dstpx[x] = color;
            x++;
        }
        startx += stride;
        x = startx;
    } 
    Py_INCREF(Py_None);
    return Py_None;
}

/*
 * DesiredAlpha: takes the alpha (floating-point, 0.0 - 1.0) and returns
 * an unsigned int in the range 0-255
 */
