import time
import pygame
try:
    import renpy
    use_renpy = 1
    import os
    #os.chdir(renpy.exports.config.searchpath[0])
    renpy_TIMEEVENT = renpy.display.core.TIMEEVENT
    PERIODIC = renpy.display.core.PERIODIC
    try:
        pygame.display.set_icon(pygame.image.load(renpy.exports.config.searchpath[0]+'/bigicon.png'))
    except:
        pass
except:
    use_renpy = 0
    PERIODIC = -1234
    renpy_TIMEEVENT = -12345
import gm6
import database
database.use_renpy = use_renpy
if use_renpy:
    database.renpy_gamedir = renpy.exports.config.searchpath[0]+'/'
import sys
import gmapi
gmapi.gm6 = gm6
import supersound_compat
supersound_compat.add_refs(gm6.replace_scripts)
gm6.renpy_PERIODIC = PERIODIC
import string

def Resolution(game):
    room = gmapi.room
    if not room.view_enabled:
        return room.room_width,room.room_height
    else:
        w = 0
        h = 0
        x = 0
        while (x<8):
            if room.view_visible[x]:
                w = max(w,room.view_wport[x]+room.view_xport[x])
                h = max(h,room.view_hport[x]+room.view_yport[x])
            x += 1
        if w and h:
            return (w,h)
    if game.resolution==0:
        return (640,480)
    elif game.resolution==1:
        return (800,600)
    elif game.resolution==5:
        return (320,240)
    else:
        print "Unknown resolution",game.resolution
    return (800,600)

def RunRoom(room):
    raise "RunRoom hit."
    for object in room.objects:
        object.Step()
    room.Draw(screen)

if not use_renpy:
    pygame.init()
gmapi.py_fasttint.init_subsystems()

def nullfunc(*args):
    pass
gm6.replace_scripts['lookup_direct'] = database.lookup_direct

gm6.verbose_calls = [
        # The engine will print when it calls these functions and what the
        # return values are.
        ]
gm6.watched_variables = [
        'clickables',
        # A message will be printed whenever these are changed.
        ]
gm6.debug_list_all_gml = ('--list-all-gml' in sys.argv) # List all GML scripts.
        # XXX at the moment, partial - does not yet list event script.
gm6.debug_list_all_script_content = ('--verbose' in sys.argv) # Take a wild guess.
gm6.debug_list_script_content = [
        # List script content for scripts or objects named here.
        ]
# gm6.replace_scripts_gml = dict for GML replacements for script
def slurpfile(fn):
    f = None
    if fn.startswith('/'):
        f = file(fn,'rb')
    else:
        f = gmapi.renpy_glue.open_r(fn)
    if f is None:
        print "Error opening",fn
    ret = string.join(f.readlines(),sep='')
    f.close()
    return ret
#gm6.replace_scripts_gml['gallery_setup'] = slurpfile('gallery_setup.gml')
#print gm6.gml2python(slurpfile('save_display.enter.gml'))
gm6.mungedicts = dict(
    glow_obj = dict(
        # XXX test for performance hit on non-Mac.
        bm_subtract='pygame.BLEND_RGBA_MULT'),
    )

#print gm6.gml2python('callfunc(8,9,10)')
#print gm6.gml2python('if c<3 and 5>4 print("BOOM!")')
#print gm6.gml2python('if (item < global.invlength - 4) show_message("oom")')
#print gm6.gml2python('with (pants) { if (item < global.invlength - 4) show_message("oom") }')
#print gm6.gml2python('if (1 or 0 and 3 and 5) { print("oom") }')
#print gm6.gml2python('if (myoption = i && options > 1){print("oom")}')
#print gm6.gml2python('if (myoption = i and options > 1){print("oom")}')
#print gm6.gml2python('if (speed > 0 || (path_position > 0 && path_position < 1)) { print("oom"); }')
#print gm6.gml2python('if (speed>0 || 1) { spaffle(); }') # Fine
#print gm6.gml2python('if (speed>0 || (1 && 2)) { spaffle(); }')
#print gm6.gml2python('if (myjob = "Guide" || myjob = "Painter" && global.sculptclass + global.danceclass + global.dramaclass + global.guide + global.kidart > 7 && global.muchat[1] = 0 && random(5) > 2) { something() }')
#print gm6.gml2python('if (x>3 && y<0) { other() }');
#print gm6.gml2python('if (not 1==2) { boom(); }')
#print gm6.gml2python('if (i[0]==4) { boom(); }')
#print gm6.gml2python('c[0,2]=4');
#print gm6.gml2python('loadup.mytext=string(load_display.filelist[mydex-1,2])')

gm6_filename = 'game.gm6'
gm6.compile_strip_gml = '--strip' in sys.argv
gm6.compile_nostrip_gml = set()
for arg in sys.argv:
    if arg.startswith('--gm6='):
        gm6_filename=arg[6:]
if "--compile" in sys.argv:
    game = gm6.GM6_File(
        #'gm6s/FatalHeartsPuzzles/joust.gm6', # Works!
        #'gm6s/FatalHeartsPuzzles/labyrinth.gm6', 
        # While necessary for the FH port, labyrinth is a rather ugly demo -
        # probably not worth converting.
        #'gm6s/asteroids.gm6',
        gm6_filename,
        'out/')
    if not '--run' in sys.argv:
        for arg in sys.argv:
            if arg.startswith('--nostrip='):
                gm6.compile_nostrip_gml.add(arg[10:])
        f = file('game.dat','w')
        game.PickleTo(f)
        f.close()
        exit(0)
else:
    try:
        exec slurpfile('loading.py') in globals(),locals()
    except:
        loading_bg = None
    game = gm6.GM6_File_FromPickle('game.dat')
#gmapi.glowing_spr.subimages[0] = pills.invert(gmapi.glowing_spr.subimages[0])

gm6.game = game
gmapi.py_gm6_game = game
#exec slurpfile('draw_header.py') in gmapi.__dict__
#class FakeEvent():
#    python = None
#butt = FakeEvent()
#butt.python = slurpfile('equip_item_globleftpressed.py')
#gmapi.equip_item.py_objectdata.py_GlobLeftPressedActionGroup = butt

def raisepoint(func):
    def real_raisepoint(*args):
        raise "Wanted to call func "+str(func)+" with "+str(args)
    return real_raisepoint

debug_history = []
debug_history_realline = ''

def debug_weigh_all():
    import gc
    types_present = dict()
    for o in gc.get_objects():
        if not types_present.has_key(type(o)):
            types_present[type(o)] = 0
        types_present[type(o)] += 1
    print 'Objects:',types_present
    return types_present

def debug_weigh():
    import gc
    types_present = dict()
    for o in gc.get_objects():
        if not types_present.has_key(type(o)):
            types_present[type(o)] = 0
        types_present[type(o)] += 1
    return types_present

def debug_weigh_cmp(old):
    new = debug_weigh()
    old = dict(old)
    kl = old.keys()
    for k in kl:
        if k in new:
            if new[k]!=old[k]:
                print k,':',old[k],'->',new[k]
            del new[k]
        else:
            print k,':',old[k],'-> 0'
        del old[k]
    for k in new:
        print k,': 0 ->',new[k]


def debug_show_fps(dbg=0):
    gm6.debug_print_fps=1
    gmapi.room.drawn_objects.append(gm6.VisibleFPSIndicator(dbg))

def debug_list_showing_objects():
    uniques = dict()
    for o in gmapi.room.objects_depthsorted:
        if type(o)==gmapi.py_ObjectInstance:
            n = o.object_index.py_objectdata.name
            if not n in uniques:
                uniques[n] = 0
            uniques[n] += 1
        else:
            print "Unexpected type",o
    print uniques

def debug_show_color(c):
    screen.fill(c,(50,50,700,500))
    gmapi.draw_text(400,300,str(c))
    pygame.display.flip()
    time.sleep(5)
def debug_count_all_particles():
    systems = 0
    particles = 0
    ttl = 0
    for o in gmapi.room.objects_depthsorted:
        if type(o)==gmapi.py_ParticleSystem:
            systems += 1
            for p in o.py_particles:
                particles += 1
                ttl += p.ttl
    print "Debug:",systems,'particle systems,', particles, 'total particles, and',ttl,'total ttl.'

def handle_command_tab():
    # Iconifying a fullscreen window leaves it occupying the screen.
    if gmapi.py_is_fullscreen:
        gmapi.window_set_fullscreen(0,loading_bg=screen.copy())
        gmapi.display_set_all(gmapi.py_reserved_varname_1.holdwidth,gmapi.py_reserved_varname_1.holdheight,gmapi.py_reserved_varname_1.frequency,32.0)
        gmapi.window_default()
gm6.handle_command_tab = handle_command_tab

def debug_prompt():
    global debug_history
    debug_history_pos = len(debug_history)
    global debug_history_realline
    surfaces = []
    lines = [u'',]
    screen.blit(gmapi.__fontcache[gm6.debugger_font].render('Enter code:',1,(92,0,220),(0,0,0,128)),(0,0))
    pygame.display.flip()
    while True:
        ev = pygame.event.wait()
        if ev.type==pygame.KEYDOWN:
            if ev.key==pygame.K_BACKSPACE:
                if len(lines[-1]):
                    lines[-1] = lines[-1][:-1]
                elif len(lines)>1:
                    surfaces.pop()
                    lines.pop()
            elif ev.key==pygame.K_TAB and ev.mod==pygame.KMOD_LMETA:
                handle_command_tab()
            elif ev.key==pygame.K_RETURN or ev.key==pygame.K_KP_ENTER:
                if lines[-1]=='':
                    debug_str = string.join(lines,sep='\012')
                    try:
                        exec debug_str
                    except:
                        print "Execution of '",
                        try:
                           print debug_str,
                        except:
                           print '(unprintable)',
                        print "' failed.",sys.exc_type,sys.exc_value,sys.exc_traceback
                        time.sleep(2)
                    return
                debug_history.append(lines[-1])
                if len(debug_history)>500:
                    debug_history = debug_history[-500:]
                debug_history_pos = len(debug_history)
                surfaces.append(gmapi.__fontcache[gm6.debugger_font].render(lines[-1]+'   ',1,(0,255,0),(0,0,0,128)))
                lines.append(u'')
            elif ev.key==pygame.K_q and ev.mod&pygame.KMOD_LMETA:
                gmapi.room.HandleKeypress(gmapi.vk_escape)
                return
            elif (not ev.unicode) or ord(ev.unicode)<32:
                if ev.key==pygame.K_n:
                    debug_history_pos += 1
                    if debug_history_pos>=len(debug_history):
                        if debug_history_pos > len(debug_history):
                            debug_history_realline = lines[-1]
                        else:
                            lines[-1] = debug_history_realline
                        debug_history_pos = 0
                    lines[-1] = debug_history[debug_history_pos]
                elif ev.key==pygame.K_p:
                    if debug_history_pos==0:
                        debug_history_pos = len(debug_history)
                        lines[-1] = debug_history_realline
                    else:
                        if debug_history_pos == len(debug_history):
                            debug_history_realline = lines[-1]
                        debug_history_pos-=1
                        lines[-1] = debug_history[debug_history_pos]
                elif ev.key==pygame.K_u:
                    lines[-1] = ''
            else:
                lines[-1] += ev.unicode
            y = 20
            for surf in surfaces:
                screen.blit(surf,(0,y))
                y += surf.get_height()
            surf = gmapi.__fontcache[gm6.debugger_font].render(lines[-1],1,(0,255,0),(0,0,0,128))
            screen.blit(surf,(0,y))
            screen.blit(gmapi.__fontcache[gm6.debugger_font].render('_ ',1,(100,100,100),(0,0,0,128)),(surf.get_width(),y))
            
            pygame.display.flip()

def WaitForFocusGain():
    # XXX untested.
    pygame.event.pump()
    ev = pygame.event.wait()
    while True:
        if ev.type==pygame.ACTIVEEVENT and ev.gain:
            return
        elif ev.type==PERIODIC:
            renpy.audio.audio.periodic()
        pygame.event.pump()
        ev = pygame.event.wait()

def handle_events():
    # Not sure where releases are handled relative to presses; at the moment,
    # returning a tuple of keypresses (which includes keyreleases), 
    # mousepresses (which includes buttonreleases.)
    pygame.event.pump()
    ev = pygame.event.poll()
    keypresses = []
    mousepresses = []
    while ev.type != pygame.NOEVENT:
        if ev.type==pygame.MOUSEBUTTONDOWN:
            if ev.button<=3:
                butt = ev.button
                if butt==3:
                    butt = 4
                gmapi.mouse_x, gmapi.mouse_y = ev.pos
                gmapi.mouse_button |= butt
                gmapi.py_mouse_pressed |= butt
                if gmapi.room.view_enabled:
                    gmapi.mouse_x += gmapi.room.view_xview[0]
                    gmapi.mouse_y += gmapi.room.view_yview[0]
                def tmpfunc(room=lastroom,ev=ev):
                    gm6.Room_MouseButtonDown(room,ev)
                mousepresses.append(tmpfunc)
            else:
                ev = pygame.event.poll()
                continue
        elif ev.type==pygame.MOUSEBUTTONUP:
            def tmpfunc(room=lastroom,ev=ev):
                gm6.Room_MouseButtonUp(room,ev)
            mousepresses.append(tmpfunc)
        elif ev.type==pygame.MOUSEMOTION:
            gmapi.mouse_x = ev.pos[0]+gmapi.room.view_xview[0]
            gmapi.mouse_y = ev.pos[1]+gmapi.room.view_yview[0]
        elif ev.type==pygame.KEYDOWN:
            # TODO when the pressed/released checks are added, may need to
            # poke them here?  Probably won't.
            if type(gmapi.keyboard_string) is gm6.GMVar:
                gmapi.keyboard_string = gmapi.keyboard_string[0]
            if ev.key==pygame.K_BACKSPACE:
                if len(gmapi.keyboard_string):
                    gmapi.keyboard_string = gmapi.keyboard_string[:-1]
            elif ev.key==pygame.K_F1 and gm6.game.f1_shows_game_info:
                gmapi.show_message("RTF rendering not yet implemented.")
            elif ev.key==pygame.K_F4 and gm6.game.f4_switches_screen_modes:
                if gmapi.py_is_fullscreen:
                    window_set_fullscreen(0)
                else:
                    window_set_fullscreen(1)
            elif ev.key==pygame.K_F11:
                try:
                    argh_py = slurpfile('argh.py')
                    print 301,argh_py
                    exec argh_py in gmapi.__dict__,gmapi.__dict__
                except:
                    print "Execution failed."
                    print sys.exc_type,sys.exc_value,sys.exc_traceback
            elif ev.key==pygame.K_F10 or ev.key==pygame.K_TAB:
                if ev.key==pygame.K_TAB and ev.mod&pygame.KMOD_LMETA:
                    handle_command_tab()
                    ev = pygame.event.poll()
                else:
                    debug_prompt()
                    ev = pygame.event.poll()
                continue
            elif ev.key==pygame.K_q and ev.mod&pygame.KMOD_LMETA:
                gmapi.py_keys_pressed[key] = 1
                def tmpfunc(room=gmapi.room):
                     room.HandleKeypress(gmapi.vk_escape)
                keypresses.append(tmpfunc)
            else:
                gmapi.keyboard_string += ev.unicode
                if len(gmapi.keyboard_string)>1024:
                    gmapi.keyboard_string = gmapi.keyboard_string[-1024:]
            if ev.key in gmapi.py_translate_keys:
                gmapi.py_keys_pressed[gmapi.py_translate_keys[ev.key]] = 1
                def tmpfunc(room=gmapi.room,key=gmapi.py_translate_keys[ev.key]):
                    room.HandleKeypress(key)
                keypresses.append(tmpfunc)
            else:
                gmapi.py_keys_pressed[ev.key] = 1
                def tmpfunc(room=gmapi.room,key=ev.key):
                    room.HandleKeypress(key)
                keypresses.append(tmpfunc)
        elif ev.type==pygame.KEYUP:
            if not ev.key in gmapi.py_translate_keys:
                gmapi.py_keys_pressed[ev.key] = 0
                def tmpfunc(key=ev.key):
                    gmapi.room.HandleKeyrelease(key)
            else:
                gmapi.py_keys_pressed[gmapi.py_translate_keys[ev.key]] = 0
                def tmpfunc(key=gmapi.py_translate_keys[ev.key]):
                    gmapi.room.HandleKeyrelease(key)
            keypresses.append(tmpfunc)
        elif ev.type==pygame.ACTIVEEVENT:
            if ev.gain==0 and gm6.game.pause_on_focus_loss:
                WaitForFocusGain()
        elif ev.type==PERIODIC:
            renpy.audio.audio.periodic()
        elif ev.type==pygame.QUIT:
            #gmapi.keyboard_key_press(gmapi.vk_escape)
            gmapi.py_keys_pressed[gmapi.vk_escape] = 1
            gmapi.room.HandleKeypress(gmapi.vk_escape)
        elif ev.type==renpy_TIMEEVENT:
            pass
        else:
            print "Unhandled event",ev
        ev = pygame.event.poll()
    return keypresses,mousepresses

def window_set_fullscreen(fs,loading_bg=None):
    global screen
    if not fs:
        gmapi.py_is_fullscreen = False
        global screen
        screen = pygame.display.set_mode(Resolution(game),0)#pygame.DOUBLEBUF)
        gm6.set_pygame_screen(screen)
    else:
        gmapi.py_is_fullscreen = True
        screen = pygame.display.set_mode(Resolution(game),pygame.FULLSCREEN)
        gm6.set_pygame_screen(screen)
    if loading_bg:
        screen.blit(loading_bg,(0,0))
        pygame.display.flip()
gmapi.window_set_fullscreen = window_set_fullscreen
window_set_fullscreen(False,loading_bg=loading_bg)
# XXX OLD datamassage
import datamassage
if gm6.use_renpy:
    exec slurpfile(renpy.exports.config.searchpath[0]+'/game-python.py') in gmapi.__dict__
    try:
        exec slurpfile(renpy.exports.config.searchpath[0]+'/game-python-full.py') in gmapi.__dict__
    except:
        pass
else:
    exec slurpfile('game-python.py') in gmapi.__dict__
    try:
        exec slurpfile('game-python-full.py') in gmapi.__dict__
    except:
        pass
global g
g = gmapi.py_reserved_varnames['global']
# Any data massaging goes here.
game.OptimizeTextures()
#gmapi.myfont.bold = 0
gmapi.room.Create()
for obj in gmapi.room.all_objects:
    if obj.object_index.py_objectdata.py_GameStartEvent:
        gm6.RunActionGroupOn(obj.object_index.py_objectdata.py_GameStartEvent,obj)
gmapi.py_effect_controllers_create()
skippedframes = 0
# Step order, from docs:
# Alarms first.
# Keyboard and mouse next.
# Step event is run.
# Instances are set to new positions.
# Collision events are handled.
# Draw events are called (multiple times for views)

# Step order from actual testing:
# Begin Step
# XXX not sure where keyreleased fits in relative to keyboard and keypressed.
# Keyboard (NON-pressed)
# Keypressed
# Mouse
# Mouse pressed
# Step
# End Step
g_mark_step_boundaries = False
g_print_fps = False
gmapi.__new_room = gmapi.room
to_skip = 0
notdone = True
del loading_bg
fasttint_Room_Draw = gmapi.py_fasttint.Room_Draw
laststarted_i = 0
while notdone:
    mouse_x, mouse_y = pygame.mouse.get_pos()
    gmapi.mouse_x = mouse_x + gmapi.room.view_xview[0];
    gmapi.mouse_y = mouse_y + gmapi.room.view_yview[0];
    started = time.time()
    if g_mark_step_boundaries:
        print "Step: fps",gmapi.fps,"skipped:",gm6.debug_fps_skippedframes,"waited",gm6.debug_fps_delay_intended
        try:
            print gmapi.girl_walker_village.path_position,'girl_walker_village.path_position'
        except:
            pass
    if int(started)!=laststarted_i:
        if g_print_fps:
            print laststarted_i,': fps=',gmapi.fps,'skip=',gm6.debug_fps_skippedframes,'sleep=',gm6.debug_fps_delay_intended
        gm6.debug_fps_delay_intended = 0
        gm6.debug_fps_skippedframes = 0
    lastroom = gmapi.room
    try:
        lastroom.StepAlarms()
        kp,mp = handle_events()
        gm6.Room_StepKey(lastroom)
        for ke in kp:
            ke()
        gm6.Room_StepMouse(lastroom) # Used to handle the key and button events,
                                # as distinct from press and release events.
        for me in mp:
            me()
        lastroom.StepEvents()
        lastroom.MoveInstances()
        lastroom.HandleCollisions()
        #predraw_time = time.time()
        #print "Took",time.time()-predraw_time
        # XXX what's with this stuff?
        gmapi.mouse_lastbutton = gmapi.mouse_button
        gmapi.py_mouse_pressed = 0
        gmapi.py_mouse_released = 0
        #dur = time.time()-started
        #if dur>lastroom.frame_duration:
        #    skippedframes += 1
        #    if skippedframes>2:
        #        gm6.debug_fps_skippedframes += skippedframes
        #        skippedframes = 0
        #    else:
        #        continue
        if to_skip<=0:
            fasttint_Room_Draw(lastroom,screen)
            pygame.display.flip()
            dur = time.time()-started
            if dur<lastroom.frame_duration:
                gm6.debug_fps_delay_intended += lastroom.frame_duration-dur
                pygame.time.delay(int((lastroom.frame_duration-dur)*1000))
            elif dur>lastroom.frame_duration:
                to_skip += dur-lastroom.frame_duration
        else:
            gm6.debug_fps_skippedframes += 1
            if to_skip>lastroom.frame_duration*5:
                to_skip = lastroom.frame_duration*5
            else:
                to_skip -= lastroom.frame_duration
    #except gmapi.py_RoomGotoException:
    #    print "Now in room",gmapi.room.name
    #    pass
    except gmapi.py_GameEndException:
        notdone = False
    except:
        raise sys.exc_type,sys.exc_value,sys.exc_traceback
    if gmapi.__new_room is not gmapi.room:
        gmapi.__room_goto_low()
    laststarted_i = int(started)

